<template>
    <div class="app-container">
        <div class="filter-container">
            <div style="display: block">
                <div class="basic_search">
                    <span>区域：</span>
                    <el-select v-model="listQuery.filter.province" clearable filterable disabled >
                        <el-option
                            v-for="item in provinceList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        >
                        </el-option>
                    </el-select>
                </div>
                <div class="basic_search">
                    <el-select v-model="listQuery.filter.city" prop="city" clearable filterable >
                        <el-option
                            v-for="item in cityList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        >
                        </el-option>
                    </el-select>
                </div>
              <div class="basic_search" style="margin-right: 10px">
                <el-button style="margin-left: 10px;" type="primary" @click="reset()">重置</el-button>
                <el-button style="margin-left: 10px;" type="primary" icon="el-icon-search" @click="searchProductSearch('查询','')">查询</el-button>
                <el-button style="margin-left: 10px;" type="primary" icon="el-icon-download" @click="exportToExcel">导出</el-button>
              </div>

            </div>
            <div style="display: block;">
                <div class="basic_search" style="padding-top: 10px;">
                    <span>时间：</span>
                    <el-date-picker
                        value-format="yyyy-MM-dd HH:mm:ss"
                        v-model="validTime"
                        type="daterange"
                        :default-time="['00:00:00','23:59:59']"
                        range-separator="-"
                        start-placeholder="开始日期"
                        end-placeholder="结束日期"
                    >
                    </el-date-picker>
                </div>
              <div class="basic_search" style="padding-top: 10px;">
                <span>对比时间：</span>
                  <el-date-picker
                      value-format="yyyy-MM-dd HH:mm:ss"
                      v-model="validTime2"
                      type="daterange"
                      :default-time="['00:00:00','23:59:59']"
                      range-separator="-"
                      start-placeholder="开始日期"
                      end-placeholder="结束日期"
                  >
                  </el-date-picker>
              </div>

            </div>
            <div style="display: block;">

            </div>

        </div>
        <div class="table_content">
            <el-table
                v-loading="listLoading"
                :key="tableKey"
                :data="productPurchaseData"
                border
                fit
                highlight-current-row
                style="width: 100%;"
            >
                <el-table-column label="序号" type="index" align="center" width="60"/>
              <el-table-column label="地区" prop="cityName" align="center">
              </el-table-column>
              <el-table-column label="时间" prop="dateRange" align="center">
              </el-table-column>
              <el-table-column label="销售数（箱）" prop="saleNumber" align="center">
              </el-table-column>
              <el-table-column label="入库数（箱）" prop="entryNumber" align="center">
              </el-table-column>
              <el-table-column label="销售额（万元）" prop="sales" align="center">
              </el-table-column>

              <el-table-column label="时间" prop="dateRange2" align="center">
              </el-table-column>
              <el-table-column label="销售数（箱）" prop="saleNumber2" align="center">
              </el-table-column>
              <el-table-column label="入库数（箱）" prop="entryNumber2" align="center">
              </el-table-column>
              <el-table-column label="销售额（万元）" prop="sales2" align="center">
              </el-table-column>

            </el-table>
            <br>
            <el-pagination
                v-show="recordTotal>0"
                :current-page="currentPage"
                :page-sizes="[20, 50, 100, 200]"
                :page-size="pageSize"
                :total="recordTotal"
                layout="total, sizes, prev, pager, next, jumper"
                background
                style="float:right;"
                @size-change="handleSizeChange"
                @current-change="handleCurrentChange"
            />
            <br>
        </div>
    </div>
</template>

<script>
import { computePageCount } from "../../utils";
import {getProductListData, exportProduct, getCityESSListData} from "../../api/productPurchaseSearch";
import {getCityListData, getProvinceListData , } from "../../api/area";
import {dictionaryAllItems} from "../../api/dictionary";

export default {
    name: "addSelfExam",
    data(){
        return{
            tableKey:'',
            validTime:['',''],
            validTime2:['',''],
            cityList:[],
            provinceList:[],
            districtList:[],
            streetList:[],
            committeeList:[],
            safetySuperVisionList:[],
            listQuery: {
                pageSize:20,
                pageIndex:1,
                filter: {
                    province: '新疆维吾尔自治区',
                    city: '',
                    starttime: '',
                    endtime: '',
                    starttime2: '',
                    endtime2: '',
                },
            },
            pageSize: 10,
            recordTotal: 0,
            currentPage: 1,
            pageTotal: 0,
            listLoading:false,
            productPurchaseData:[],
        }
    },
    created() {
        // this.getProductList()
        this.initValidTime()
        this.getProvince()
        this.changeArea("province");
        // this.getProductList()
    },
    watch: {
    },
    methods:{
        async getProductList(){
            this.listLoading = true
            if( this.validTime !== null ){
                this.listQuery.filter.starttime = this.validTime[0]
                this.listQuery.filter.endtime = this.validTime[1]
              this.listQuery.filter.starttime2 = this.validTime2[0]
              this.listQuery.filter.endtime2 = this.validTime2[1]
            }else{
                this.listQuery.filter.starttime = ''
                this.listQuery.filter.endtime = ''
                this.listQuery.filter.starttime2 = ''
                this.listQuery.filter.endtime2 = ''
            }
            let res = await getCityESSListData(this.listQuery)
            if(res.data.code === "200"){
                this.recordTotal = res.data.result.total
                this.pageSize = res.data.result.size
                this.pageTotal = computePageCount(res.data.result.total, res.data.result.size)
                this.currentPage = res.data.result.current
                this.productPurchaseData = res.data.result.result
            }else{
                this.$message({
                    type:'warning',
                    message:res.data.message
                })
            }
            this.listLoading = false
        },

        async exportToExcel(){
            if( this.validTime !== null ){
                this.listQuery.filter.starttime = this.validTime[0]
                this.listQuery.filter.endtime = this.validTime[1]
                this.listQuery.filter.starttime2 = this.validTime2[0]
                this.listQuery.filter.endtime2 = this.validTime2[1]
            }else{
                this.listQuery.filter.starttime = ''
                this.listQuery.filter.endtime = ''
                this.listQuery.filter.starttime2 = ''
                this.listQuery.filter.endtime2 = ''
            }
            let res = await getCityESSListData(this.listQuery)
            if(res.data.code === '200'){
                if(res.data.result === null ||res.data.result === [] || res.data.result.length === 0){
                    this.$message({
                        type:'warning',
                        message:'无数据可导出'
                    })
                }else{
                    let allData = res.data.result.result
                    import('@/vendor/Export2Excel').then((excel) => {
                        const tHeader = [
                            '地区',
                            '时间',
                            '销售数(箱)',
                            '入库数(箱)',
                            '时间',
                            '销售数(箱)',
                            '入库数(箱)',
                        ]
                        const filterVal = [
                            'cityName',
                            'dateRange',
                            'saleNumber',
                            'entryNumber',
                            'dateRange2',
                            'saleNumber2',
                            'entryNumber2',
                        ]
                        const data = this.formatJson(filterVal, allData)
                        excel.export_json_to_excel({
                            header: tHeader,
                            data,
                            filename: '地区进销存对比'
                        })
                    })
                }

            }else{
                this.$message({
                    message:res.data.message,
                    type:'warning'
                })
            }
        },

        formatJson(filterVal, jsonData) {
            return jsonData.map(v => filterVal.map(j => v[j]))
        },

        initValidTime(){
            const end = new Date();
            this.validTime[0] = end.toISOString().slice(0, 10) + " 00:00:00";
            this.validTime[1] = end.toISOString().slice(0, 10) + " 23:59:59";
            this.validTime2[0] = end.toISOString().slice(0, 10) + " 00:00:00";
            this.validTime2[1] = end.toISOString().slice(0, 10) + " 23:59:59";
        },

        async getProvince(){
            let res = await getProvinceListData()
            if(res.data.code === "200"){
                this.provinceList = res.data.result.provinceList
            }
        },//获取省

        async changeArea(value){
            if(value === 'province'){
                this.listQuery.filter.city = ''
                this.listQuery.filter.district = ''
                this.listQuery.filter.street = ''
                this.listQuery.filter.committee = ''
                this.areaListQuery = {
                    type: 2,
                    parenttype: 1,
                    parentname: this.listQuery.filter.province,
                }
                let res = await getCityListData(this.areaListQuery)
                if(res.data.code === "200"){
                    this.cityList = res.data.result
                }
            }else if(value === 'city'){
                this.listQuery.filter.district = ''
                this.listQuery.filter.street = ''
                this.listQuery.filter.committee = ''
                this.areaListQuery = {
                    type: 3,
                    parenttype: 2,
                    parentname: this.listQuery.filter.city,
                }
                let res = await getCityListData(this.areaListQuery)
                if(res.data.code === "200"){
                    this.districtList = res.data.result
                }
            }else if(value === 'district'){
                this.listQuery.filter.street = ''
                this.listQuery.filter.committee = ''
                this.areaListQuery = {
                    type: 4,
                    parenttype: 3,
                    parentname: this.listQuery.filter.district,
                }
                let res = await getCityListData(this.areaListQuery)
                if(res.data.code === "200"){
                    this.streetList = res.data.result
                }
            }else if(value === 'street'){
                this.listQuery.filter.committee = ''
                this.areaListQuery = {
                    type: 5,
                    parenttype: 4,
                    parentname: this.listQuery.filter.street,
                }
                let res = await getCityListData(this.areaListQuery)
                if(res.data.code === "200"){
                    this.committeeList = res.data.result
                }
            }
        },//市、镇、街道、委员会

        reset(){
            this.listQuery= {
                pageSize: 10,
                pageIndex: 1,
                filter: {
                    province: '新疆维吾尔自治区',
                    city: '',
                    starttime: '',
                    endtime: '',
                    starttime2: '',
                    endtime2: '',
                },
            }
            this.validTime = ['','']
            this.validTime2 = ['','']
            this.initValidTime()
            this.getProductList()
        },

        searchProductSearch(){
            this.listQuery.pageIndex = 1
            const date1 = new Date(this.validTime[0]);
            const date2 = new Date(this.validTime[1]);
            const date3 = new Date(this.validTime2[0]);
            const date4 = new Date(this.validTime2[1]);
            const differenceInMs = Math.abs(date2 - date1);
            const differenceInDays = differenceInMs / (1000 * 60 * 60 * 24)
            const differenceInMs2 = Math.abs(date4 - date3);
            const differenceInDays2 = differenceInMs2 / (1000 * 60 * 60 * 24)
            if(differenceInDays > 32 || differenceInDays2 > 32){
                this.$message({
                    type: 'warning',
                    message: '查询时间或对比时间跨度超过一个月的，请联系管理员查询数据'
                })
                return
            }
            this.getProductList()
        },

        handleSizeChange(val) {
            this.listQuery.pageSize = val
            this.getProductList()
        },
        handleCurrentChange(val) {
            this.listQuery.pageIndex = val
            this.getProductList()
        },
    },
}
</script>

<style scoped>
.basic_search{
    display:inline-block;
}

</style>
